/*
 *  THIS IS FREE SOFTWARE; (C) JONAS FORSSLUND 2003
 *  YOU MAY DISTRIBUTE IT, OR MODIFY IT _ONLY_ SUBJECTED TO THE LICENSE GNU GPL
 */
import java.util.*;

 /**
  * Thiws Class will take care of all position->moves stuff
  * it will interact with FEN and moves in PGN
  *
  * You will need one FenHax per game of course!
  * @Author Jonas Forsslund 2003
  * @Version 1.0 2003-07-31
  */

  class ttchess_fenhax {

      /* Constructor */
      ttchess_fenhax(){
          halfMoves=0;
          moves=new ArrayList();
          fen = new ArrayList();
          fen.add("rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR");
          //moves=new Vector();
          //fen = new Vector();
      }



      int[] mask(int[] b1, int[] b2){
          int[] output=new int[64];
          for(int i=0;i<64;i++){
              if(b2[i]!=b1[i]){
                  if(b2[i]=='.')
                      output[i]=-b1[i];
                  else
                      output[i]=b2[i];
              }
              else
                  output[i] = b2[i]-b1[i];
          }
          return output;
      }

      /**
       * This will add a position (FEN) to the fenlist
       */
      void add(String aFen){

          if(!validateFen(aFen)){
	     System.out.println("Invalid FEN: " + aFen);
	     return;
	  }

          if(aFen.equals("8/8/8/8/8/8/8/8")){
	      //System.out.println("FenHax says: Empty board");
	     return;
          }

          if(aFen.equals("rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR")){
	      fen.clear();
              moves.clear();
	      //System.out.println("\n\n\n\nCleared moves!!\n\n");
	      fen.add(aFen);
          }

          fen.add(aFen);
             

//          System.out.println(aFen + "fen.size() "+fen.size());

          if(fen.size()>2){
	      //printFenListBoards();
              add2moveList(mask(fen2board((String)fen.get(fen.size()-2)),fen2board(aFen)));
}

      }

      /**
       * Check if given FEN is valid
       */
      boolean validateFen(String aFen){
           /* Only check board part of FEN */
	   if(aFen.indexOf(' ')>0){
	     aFen = aFen.substring(0,aFen.indexOf(' '));
	   }

           /* FEN contains 7 '/' */
           int s=0;
           for(int c=0;c<aFen.length();c++){
	     if(aFen.charAt(c) == '/') s++;
	   }
	   if(s!=7) return false;

	   /* FEN has 8 empty squares/pieces per row */
           int x=0;
           for(int c=0;c<aFen.length();c++){
	     if(aFen.charAt(c) == '/'){
	       if(x!=8) return false;
	       else x=0;
	     }
	     else
	     {
		if(aFen.charAt(c) >= '1' && aFen.charAt(c)<= '8')
		  x+= aFen.charAt(c)-'1' ;
		x++;
	     }
	   }
           if(x!=8) return false;

	   return true;
      }

      /**
       * Prints the current list of positions
       */
      void printFenList(){
          for(int i=0;i<fen.size();i++){
              System.out.println(i + "\t" + (String)fen.get(i));
          }
      }
      void printFenListBoards(){
          for(int i=0;i<fen.size();i++){
	      printBoard(fen2board((String)fen.get(i)));
              System.out.print((String)fen.get(i) + "\n\n");
          }
      }


      /**
       * Prints a board from fen-list given its list number
       */
      void printBoard(int fenNr){
          if(fenNr>=fen.size())
              return;
          printBoard(fen2board((String)fen.get(fenNr)));
      }

      void printBoard(int[] board){
          for(int chr=0;chr<64;chr++){
              if(board[chr]<0)
                  System.out.print("-" + (char)(Math.abs(board[chr])));
              else if(board[chr]==0)
                  System.out.print(", ");
              else
                  System.out.print((char)board[chr] + " ");
              if((chr+1)%8==0)
                  System.out.print("\n");
          }
      }


      String pos2xy(int pos){
          String s = "" + (char)((pos)%8+'a') + "" + (8-pos/8);
          return s;
      }

      void add2moveList(int[] mask){
          for(int chr=0;chr<64;chr++){
              if(mask[chr]<0){
                  String s=""+(char)(Math.abs(mask[chr]))+""+pos2xy(chr);
                  moves.add(s+"-");
              }
          }
          for(int chr=0;chr<64;chr++){
              if(mask[chr]>0){
                  String s=(String)moves.get(moves.size()-1);
                  s=s+"" + pos2xy(chr);
                  moves.set(moves.size()-1,s);
              }
          }

	  /* Check if the last move is a "updated" move, like a slowly moved rook is registered twice*/
	  if(moves.size()>=2){
	    if( ((String)moves.get(moves.size()-1)).charAt(0) == ((String)moves.get(moves.size()-2)).charAt(0)){
              String s=((String)moves.get(moves.size()-2)).substring(0,3);
              String s2=((String)moves.get(moves.size()-1)).substring(3,6);
              moves.set(moves.size()-1,s+s2);
	      moves.remove(moves.size()-2);
	    }
	  }

	  /* Check for castling */
	  if(moves.size()>=2){
	    if( ((String)moves.get(moves.size()-2)).equals("Ke1-g1") && ((String)moves.get(moves.size()-1)).equals("Rh1-f1")){
	      moves.remove(moves.size()-1);
              moves.set(moves.size()-1,"O-O");
	    }
	    if( ((String)moves.get(moves.size()-2)).equals("Ke1-c1") && ((String)moves.get(moves.size()-1)).equals("Ra1-d1")){
	      moves.remove(moves.size()-1);
              moves.set(moves.size()-1,"O-O-O");
	    }
	    if( ((String)moves.get(moves.size()-2)).equals("ke8-g8") && ((String)moves.get(moves.size()-1)).equals("rh8-f8")){
	      moves.remove(moves.size()-1);
              moves.set(moves.size()-1,"O-O");
	    }
	    if( ((String)moves.get(moves.size()-2)).equals("ke8-c8") && ((String)moves.get(moves.size()-1)).equals("ra8-d8")){
	      moves.remove(moves.size()-1);
              moves.set(moves.size()-1,"O-O-O");
	    }
	  }

	  /* Check for promotion */
	  //String s = (String)moves.get(moves.size()-1));
	  //if(s.charAt(0)=='P' && s.charAt(2)=='7' && s.charAt(4)=='8')

          if(moves.size()>3){
	  /* Check for en passant */
	  String s = (String)moves.get(moves.size()-1);
	  if( s.length()==3 && s.charAt(0)=='p' && s.charAt(2) == '5')
	  {
		String s1 = (String)moves.get(moves.size()-3);
		String s2 = (String)moves.get(moves.size()-2);
		if(s1.charAt(0)=='p' && s1.charAt(2)=='7' && s1.charAt(5)=='5' &&
		s2.charAt(0)=='P' && s2.charAt(2)=='5' && s2.charAt(5)=='6' && s1.charAt(4)==s2.charAt(4)){
		  moves.remove(moves.size()-1);
		  moves.set(moves.size()-1, s2 + " ep");
		}
	  }
	  if( s.length()==3 && s.charAt(0)=='P' && s.charAt(2) == '4')
	  {
		String s1 = (String)moves.get(moves.size()-3);
		String s2 = (String)moves.get(moves.size()-2);
		if(s1.charAt(0)=='P' && s1.charAt(2)=='2' && s1.charAt(5)=='4' &&
		s2.charAt(0)=='p' && s2.charAt(2)=='4' && s2.charAt(5)=='3' && s1.charAt(4)==s2.charAt(4)){
		  moves.remove(moves.size()-1);
		  moves.set(moves.size()-1, s2 + " ep");
		}
	  }
          }






          //printBoard(mask);
	  //System.out.print("\n\n");

      }



      void printMoves(){
	  System.out.println("\nMoves: ");
          for(int i=0;i<moves.size();i++){
	      System.out.print("\t\t" + (String)moves.get(i) );
	      if(i%2!=0)
	        System.out.print("\n");
          }
	  System.out.println("\n");
      }

      /**
       * Returns nice movelist
       */
      String getMoveList(){
        String s="";
        for(int i=0;i<moves.size();i++){

	  /* Move number */
	  if(i%2==0)
	    s+=(""+(int)(i/2+1)+".");

	  String move =(String)moves.get(i);
	  move = (move.substring(0,1)).toUpperCase() + move.substring(1);
	  if(move.charAt(0)=='P' || move.charAt(0)=='p')
	    s+= move.substring(1) + " ";
	  else
	    s+= move + " ";
	}
	return s;
      }

      /**
       * Returns nice movelist, <table>-formated
       */
      String getMoveListTable(){
        String s="<TABLE>";
	int i;
        for(i=0;i<moves.size();i++){

	  /* Move number */
	  if(i%2==0)
	    s+=("<TR><TD>"+(int)(i/2+1)+".");
	  else
	    s+="<TD>";
	  String move =(String)moves.get(i);
	  move = (move.substring(0,1)).toUpperCase() + move.substring(1);
	  if(move.charAt(0)=='P' || move.charAt(0)=='p')
	    s+= move.substring(1) + " ";
	  else
	    s+= move + " ";

	  s+="</TD>";
	  if(i%2!=0)
	    s+=("</TR>");

	}
	if(i%2!=0)
	  s+="<TD>...</TD></TR>";
	s+="</TABLE>";
	return s;
      }




      /**
       * Returns a 64-array of a given fen
       *
       */
      int[] fen2board(String aFen){
          int[] board = new int[64];
          int square=0;
          int chr=0;

          while(square<64){
              char c = aFen.charAt(chr);
              if(c=='r'||c=='R'||c=='n'||c=='N'||c=='b'||c=='B'||c=='q'||c=='Q'||c=='k'||c=='K'||c=='p'||c=='P'){
                  board[square]=c;
                  square++;
              }
              if(c>='1' && c<='8'){
                  for(int i=0;i<c-'1'+1;i++){
                      board[square]='.';
                      square++;
                  }
              }
              chr++;
          }
          return board;
      }





      int halfMoves;
      //Vector moves;
      //Vector fen;
      ArrayList moves;
      ArrayList fen;
  }
